<template>
  <div id="vlue-dev-bottom-area">
    <h3>File Settings</h3>
    <button class="vlue-dev-bottom-area-button"
      type="button" v-on:click="downloadGeneratedWebsite()">
      <span>Download Generated Website</span>
      <div class="vlue-dev-bottom-area-button-spinner" v-if="websiteGenerationSpinner"></div>
    </button>
    <button class="vlue-dev-bottom-area-button"
      type="button" v-on:click="downloadData()">
      <span>Download JSON Data</span>
    </button>
    <button class="vlue-dev-bottom-area-button"
      type="button" v-on:click="saveChanges()">
      <span>Save Changes</span>
    </button>
    <button class="vlue-dev-bottom-area-button"
      type="button" v-on:click="revertChanges()">
      <span>Revert Changes</span>
    </button>
    <button class="vlue-dev-bottom-area-button"
      type="button" v-on:click="cleanSlate()">
      <span>Clean Slate</span>
    </button>
  </div>
</template>

<script lang="ts">
import Vue from 'vue'
import store from '../../store/store'
import { mapState } from 'vuex'

export default Vue.extend({
  computed: {
    ...mapState([
      'website',
      'websiteGenerationSpinner',
    ]),
  },
  methods: {
    downloadGeneratedWebsite() {
      store.commit("downloadGeneratedWebsite");
    },
    downloadData() {
      const dataString = "data:text/json;charset=utf-8,"
                       + encodeURIComponent(JSON.stringify(this.website, null, 2));
      const element    = document.createElement('a');
      element.setAttribute("href", dataString);
      element.setAttribute("download", "website.json");
      document.body.appendChild(element); // required for firefox
      element.click();
      element.remove();
    },
    saveChanges() {
      store.commit("saveChanges");
    },
    revertChanges() {
      store.dispatch('changeWebsiteState', { mutation: 'getWebsiteJson' });
    },
    cleanSlate() {
      store.dispatch('changeWebsiteState', { mutation: 'cleanSlate' });
    },
  },
})
</script>

<style lang="scss">
@import "../../style/vars.scss";

html #app .vlue-website {
  #vlue-dev-bottom-area {
    transition: $vlue-transition-duration;
    overflow: hidden;
    > h3 {
      padding: 20px 40px;
      margin: 10px 10px 0;
      border-radius: 5px;
      background: white;
      display: inline-block;
      color: black;
      font-size: 14px;
    }
    .vlue-dev-bottom-area-button {
      display: block;
      padding: 20px 20px 20px 40px;
      margin: 10px;
      border-radius: 5px;
      border: none;
      background: $vlue-website-default-bg-color;
      color: white;
      transition: $vlue-transition-duration;
      &:hover {
        color: $vlue-outside-website-bg-color;
        padding: 20px 20px 20px 60px;
      }
      &:active {
        transition: 0s;
        padding: 20px 20px 20px 40px;
      }
      > * {
        vertical-align: middle;
      }
      .vlue-dev-bottom-area-button-spinner {
        width: 10px;
        height: 10px;
        border: 5px
        solid $vlue-outside-website-bg-color;
        border-color:
          $vlue-outside-website-bg-color
          $vlue-outside-website-bg-color
          transparent
          transparent;
        border-radius: 50%;
        animation: spinning 0.25s linear infinite;
        display: inline-block;
        margin: -5px 0 -5px 20px;
      }
    }
  }
}
.dev #vlue-dev-bottom-area {
  padding-bottom: 100px;
  height: auto;
}
#app:not(.dev) #vlue-dev-bottom-area {
  height: 0;
}
@keyframes spinning {
  from {
    transform: rotate(0deg);
  }
  to {
    transform: rotate(360deg);
  }
}
</style>
